#ifndef PHONG_FX
#define PHONG_FX

#include "EffectFunction.fx"


//====================================================================================================
// Struct
//----------------------------------------------------------------------------------------------------

/// tHsNZVF[_֓nf[^
struct PHONG_VS_OUTPUT
{
    float4 mPosition		: POSITION;
    float2 mUV				: TEXCOORD0;
    float4 mColor			: TEXCOORD1;
};


//====================================================================================================
// Shader
//----------------------------------------------------------------------------------------------------

/// tHo[ebNXVF[_
LAMBERT_VS_OUTPUT PhongVS(
	float4 position	: POSITION,	// _W
	float2 uv		: TEXCOORD,	// eNX`W
	float3 normal	: NORMAL	// @
)
{
	// o̓f[^p
	PHONG_VS_OUTPUT sOut = (PHONG_VS_OUTPUT)0;


	// ʒuWݒ
	sOut.mPosition = mul(position, gWVP);


	// MEMO:Ȃvf0ŏ̂ŖI1ŏ܂B
	// UVWݒ
	float4 uv4 = float4(uv.x, uv.y, 1.0f, 1.0f);
	sOut.mUV = mul(uv4, gUVMatrix).xy;


	// o[ggUˌZo
	sOut.mColor.rgb += CalcLambert(normal);
	
	// Z
	sOut.mColor.rgb += CalcAmbient();
	
	// tHʔˌZo
	sOut.mColor.rgb += CalcSpecular(normal, position);


	// MEMO:ʂ̕ϐpӂǂł傤B
	// At@sł1ɐݒ
	sOut.mColor.a = 1;


	// o
	return sOut;
}

/// tHsNZVF[_
float4 PhongPS(PHONG_VS_OUTPUT sIn) : COLOR
{
	// sNZJ[p
	float4 pixelColor = sIn.mColor;

	// fBt[YeNX`TvO
	pixelColor *= DiffuseTextureSampling(sIn.mUV);


    return pixelColor;
}


#endif // PHONG_FX
