#ifndef SKIN_ANIMATION_TECHNIQUES_FX
#define SKIN_ANIMATION_TECHNIQUES_FX

#include "Skin_Wireframe.fx"
#include "Skin_Constant.fx"


//====================================================================================================
// Technique
//----------------------------------------------------------------------------------------------------

/// C[t[
technique Wireframe
{
    // C[t[`pX
    pass PassWireFrame
    {
        // _[Xe[gݒ
        AlphaBlendEnable = False;
        CullMode = CCW;
        ZEnable = True;
        ZWriteEnable = True;
        
        // C[t[w
        FillMode = WireFrame;
        
        
        // o[ebNXVF[_
        VertexShader = compile vs_2_0 SkinWireframeVS();
        
        // sNZVF[_
        PixelShader  = compile ps_2_0 SkinWireframePS();
    }
}

/// RX^g
technique Constant
{
	// \bh`pX
	pass PassSolid
	{
		// _[Xe[gݒ
		AlphaBlendEnable = True;
		SrcBlend = SrcAlpha;
		DestBlend = InvSrcAlpha;
		Lighting = False;
		CullMode = CCW;
		ZEnable = True;
		ZWriteEnable = True;

		// \bhw
		FillMode = Solid;


		// o[ebNXVF[_
		VertexShader = compile vs_2_0 SkinConstantVS();

		// sNZVF[_
		PixelShader  = compile ps_2_0 SkinConstantPS();
	}

	// C[t[`pX
	pass PassWireFrame
	{
		// _[Xe[gݒ
		AlphaBlendEnable = False;
		CullMode = CCW;
		ZEnable = True;
		ZWriteEnable = True;

		// C[t[w
		FillMode = WireFrame;


		// o[ebNXVF[_
		VertexShader = compile vs_2_0 SkinWireframeVS();

		// sNZVF[_
		PixelShader  = compile ps_2_0 SkinWireframePS();
	}
}

/// o[g
technique Lambert
{
}

/// tH
technique Phong
{
}


#endif // SKIN_ANIMATION_TECHNIQUES_FX
