#ifndef VIEWTERRAIN_H
#define VIEWTERRAIN_H

#include "IMainGameView.h"

#include "Blast/Graphic/ICamera.h"
#include "Blast/Graphic/DirectX9/ShaderEffectDX9.h"
#include "TerrainGrid.h"
#include "TerrainChipset.h"

namespace TerrainTag { enum ETerrainTag; }
namespace ChipsetTag { enum EChipsetTag; }

class MainGameViewManager;
class MainGameDataManager;	//< QƂ邾Ȃ̂Ő錾Ńrhʂ炵H


/// n`̕`SBMVCVB
class ViewTerrain : public IMainGameView
{
	//====================================================================================================
	// Operation
	//----------------------------------------------------------------------------------------------------

public:
	/// RXgN^
	ViewTerrain(MainGameViewManager* pViewManager);
	/// fXgN^
	~ViewTerrain();

	/// XV
	void Update(float delta);
	/// `
	void Render() override;

	/// n`̃`bvZbgݒ
	void SetChipset(ChipsetTag::EChipsetTag eTag);


	//====================================================================================================
	// Property
	//----------------------------------------------------------------------------------------------------

public:
	bool IsEnable() const;			///< XVtO擾
	void SetEnable(bool value);		///< XVtOݒ
	bool IsVisible() const;			///< `tO擾
	void SetVisible(bool value);	///< `tOݒ


	//====================================================================================================
	// Field
	//----------------------------------------------------------------------------------------------------

private:
	/// `Ǘ
	MainGameViewManager* mPViewManager;

	// DataManagerɂBłViewɂH
	//SP<Blast::Graphic::ICamera> mPCamera;	///< J

	SP<TerrainChipset> mPChipset;					///< n`̃`bvZbg
	SP<Blast::Graphic::ShaderEffectDX9> mPShader;	///< `bv`悷VF[_[


	bool mIsEnable;		///< XVtO
	bool mIsVisible;	///< `tO

	
	//====================================================================================================
	// Implement
	//----------------------------------------------------------------------------------------------------

private:
	/// Ǘ擾
	SP<MainGameDataManager> GetDataMgr();
};

#endif // VIEWTERRAIN_H